#include "plugin.h"
#include "farkeys.h"

static struct PluginStartupInfo Info;
static FARSTANDARDFUNCTIONS FSF;
static int (WINAPI *SetEditorOption)(int EditorID, const char *szName, void *Param);
static int (WINAPI *GetEditorSettings)(int EditorID, const char *szName, void *Param);

BOOL IsOldFAR;
struct EditorInfo ei;
static const char d[] = "%d";

#include "esc-tsc-lang.h"
#include "common.h"
//#define DEBUG
#include "debug.h"

#define MAKEFARVERSION(major,minor,build) ( ((major)<<8) | (minor) | ((build)<<16))

BOOL WINAPI _export LibMain(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
{
  return TRUE;
}

#include "msg.c"
#include "dialoginit.c"

void WINAPI _export SetStartupInfo(const struct PluginStartupInfo *psi)
{

  Info=*psi;
  IsOldFAR=TRUE;
  if (psi->StructSize >= sizeof(struct PluginStartupInfo))
  {
    FSF=*psi->FSF;
    Info.FSF=&FSF;
    IsOldFAR=FALSE;
  }
}

long WINAPI MyDialog(HANDLE hDlg,int Msg,int Param1,long Param2)
{
  struct FarDialogItem DlgEdit;
  struct FarDialogItemData DlgData;
  int i;
  static BOOL StatusBar;

  switch (Msg)
  {
    case DN_INITDIALOG:
      Info.SendDlgMessage(hDlg,DM_SETFOCUS,1,0);
      StatusBar = FALSE;
      return TRUE;
    case DN_MOUSECLICK:
      if (StatusBar)
      {
        DlgData.PtrLength=28;
        DlgData.PtrData=GetMsg(MWaiting);
        Info.SendDlgMessage(hDlg,DM_SETTEXT,8,(long)&DlgData);
        StatusBar = FALSE;
      }
      return FALSE;
    case DN_KEY:
      if (StatusBar)
      {
        DlgData.PtrLength=28;
        DlgData.PtrData=GetMsg(MWaiting);
        Info.SendDlgMessage(hDlg,DM_SETTEXT,8,(long)&DlgData);
        StatusBar = FALSE;
      }
      if (Param1 == 3 || Param1 == 4 || Param2 != KEY_ENTER)
        return FALSE;
      Param1 = 3;
    case DN_BTNCLICK:
      switch (Param1)
      {
        case 3:
          Info.SendDlgMessage(hDlg,DM_GETDLGITEM,2,(long)&DlgEdit);
          i = 0; //no etry == zero
          FSF.sscanf(DlgEdit.Data,d,&i);
          FSF.sprintf(DlgEdit.Data,d,i);
          Info.SendDlgMessage(hDlg,DM_SETDLGITEM,2,(long)&DlgEdit);
          #ifdef DEBUG
          WRITE_STR("\nUpdate: i = ");
          WRITE_INT(i);
          WRITE_STR("\n");
          #endif
          Info.SendDlgMessage(hDlg,DM_GETDLGITEM,1,(long)&DlgEdit);
          if (SetEditorOption(ei.EditorID,DlgEdit.Data,(void *)&i))
          {
            Info.SendDlgMessage(hDlg,DM_ADDHISTORY,1,(long)DlgEdit.Data);
            FSF.sprintf(DlgEdit.Data,d,i);
            Info.SendDlgMessage(hDlg,DM_ADDHISTORY,2,(long)DlgEdit.Data);
            DlgData.PtrLength=28;
            DlgData.PtrData=GetMsg(MUpdateSuccessfull);
            Info.SendDlgMessage(hDlg,DM_SETTEXT,8,(long)&DlgData);
            StatusBar = TRUE;
          }
          else
          {
            DlgData.PtrLength=28;
            DlgData.PtrData=GetMsg(MUpdateFailed);
            Info.SendDlgMessage(hDlg,DM_SETTEXT,8,(long)&DlgData);
            StatusBar = TRUE;
          }
          break;
        case 4:
          Info.SendDlgMessage(hDlg,DM_GETDLGITEM,1,(long)&DlgEdit);
          if (GetEditorSettings(ei.EditorID,DlgEdit.Data,(void *)&i))
          {
            Info.SendDlgMessage(hDlg,DM_ADDHISTORY,1,(long)DlgEdit.Data);
            Info.SendDlgMessage(hDlg,DM_GETDLGITEM,2,(long)&DlgEdit);
            #ifdef DEBUG
            WRITE_STR("\nCheck: i = ");
            WRITE_INT(i);
            WRITE_STR("\n");
            #endif
            FSF.sprintf(DlgEdit.Data,d,i);
            Info.SendDlgMessage(hDlg,DM_SETDLGITEM,2,(long)&DlgEdit);
            Info.SendDlgMessage(hDlg,DM_SHOWITEM,2,1);
            DlgData.PtrLength=28;
            DlgData.PtrData=GetMsg(MCheckSuccessfull);
            Info.SendDlgMessage(hDlg,DM_SETTEXT,8,(long)&DlgData);
            StatusBar = TRUE;
          }
          else
          {
            DlgData.PtrLength=28;
            DlgData.PtrData=GetMsg(MCheckFailed);
            Info.SendDlgMessage(hDlg,DM_SETTEXT,8,(long)&DlgData);
            StatusBar = TRUE;
          }
          break;
      }
      Info.SendDlgMessage(hDlg,DM_EDITUNCHANGEDFLAG,1,1);
      Info.SendDlgMessage(hDlg,DM_EDITUNCHANGEDFLAG,2,1);
      Info.SendDlgMessage(hDlg,DM_SETFOCUS,1,0);
      return TRUE;
    case DN_HOTKEY:
      switch (Param1)
      {
        case 5:
          Info.SendDlgMessage(hDlg,DM_SETFOCUS,1,0);
          break;
        case 6:
          Info.SendDlgMessage(hDlg,DM_SETFOCUS,2,0);
          break;
        default:
          return TRUE;
      }
      return FALSE;
  }
  return Info.DefDlgProc(hDlg,Msg,Param1,Param2);
}

HANDLE WINAPI _export OpenPlugin(int OpenFrom,int Item)
{

  static const char ParamsHistory[] = "ESC-TSC-Params";
  static const char SettingsHistory[] = "ESC-TSC-Values";
  static const struct InitDialogItem PreDialogItems[] = {
    DI_DOUBLEBOX  ,3  ,1  ,32 ,9  ,0    ,0                      ,0                                                   ,0 ,(char *)MTitle,
    DI_EDIT       ,15 ,2  ,30 ,0  ,TRUE ,(DWORD)ParamsHistory   ,DIF_HISTORY|DIF_USELASTHISTORY|DIF_MANUALADDHISTORY ,0 ,"",
    DI_EDIT       ,15 ,4  ,30 ,0  ,0    ,(DWORD)SettingsHistory ,DIF_HISTORY|DIF_USELASTHISTORY|DIF_MANUALADDHISTORY ,0 ,"",
    DI_BUTTON     ,8  ,6  ,0  ,0  ,0    ,0                      ,DIF_BTNNOCLOSE|DIF_CENTERGROUP                      ,1 ,(char *)MUpdate,
    DI_BUTTON     ,8  ,6  ,0  ,0  ,0    ,0                      ,DIF_BTNNOCLOSE|DIF_CENTERGROUP                      ,0 ,(char *)MCheck,
    DI_TEXT       ,4  ,2  ,0  ,0  ,0    ,0                      ,0                                                   ,0 ,(char *)MParam,
    DI_TEXT       ,4  ,4  ,0  ,0  ,0    ,0                      ,0                                                   ,0 ,(char *)MValue,
    DI_TEXT       ,4  ,7  ,0  ,0  ,0    ,0                      ,0                                                   ,0 ,(char *)MStatus,
    DI_TEXT       ,4  ,8  ,0  ,0  ,0    ,0                      ,0                                                   ,0 ,(char *)MWaiting,
  };
  static struct FarDialogItem DialogItems[sizeof(PreDialogItems)/sizeof(PreDialogItems[0])];
  static HMODULE hEsc = NULL;
  static BOOL FirstRun = TRUE;
  const char *WMsg[2];

  #ifdef DEBUG
  OPEN();
  #endif

  if (FirstRun)
  {
    InitDialogItems(PreDialogItems,DialogItems,sizeof(PreDialogItems)/sizeof(PreDialogItems[0]));

    if (!hEsc)
    {
      hEsc=GetModuleHandle("esc.dll");
    }
    if (!GetEditorSettings && hEsc)
    {
      GetEditorSettings=(int (WINAPI*)(int, const char*, void*))GetProcAddress(hEsc,"GetEditorSettings");
    }
    if (!SetEditorOption && hEsc)
    {
      SetEditorOption=(int (WINAPI*)(int, const char*, void*))GetProcAddress(hEsc,"SetEditorOption");
    }
    if (!SetEditorOption || !GetEditorSettings)
    {
      WMsg[0] = GetMsg(MTitle);
      WMsg[1] = GetMsg(MNoESC);
      Info.Message(Info.ModuleNumber,FMSG_WARNING|FMSG_MB_OK,NULL,WMsg,2,0);
      return (INVALID_HANDLE_VALUE);
    }
    FirstRun = FALSE;
  }
  Info.EditorControl(ECTL_GETINFO,(void *)&ei);
  Info.DialogEx(Info.ModuleNumber,-1,-1,36,11,NULL,DialogItems,sizeof(PreDialogItems)/sizeof(PreDialogItems[0]),0,0,MyDialog,0);

  #ifdef DEBUG
  CLOSE();
  #endif

  return (INVALID_HANDLE_VALUE);
}

void WINAPI _export GetPluginInfo(struct PluginInfo *pi)
{
  static const char *MenuStrings[1];

  if (!IsOldFAR)
  {
    pi->StructSize=sizeof(struct PluginInfo);
    pi->Flags=PF_EDITOR|PF_DISABLEPANELS;
    MenuStrings[0]=GetMsg(MTitle);
    pi->PluginMenuStrings=MenuStrings;
    pi->PluginMenuStringsNumber=1;
  }
}
